using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserOrder;
namespace CMSMicroservice.Protobuf.Validator.UserOrder;

public class CreateNewUserOrderRequestValidator : AbstractValidator<CreateNewUserOrderRequest>
{
    public CreateNewUserOrderRequestValidator()
    {
        RuleFor(model => model.Amount)
            .NotNull();
        RuleFor(model => model.PackageId)
            .NotNull();
        RuleFor(model => model.PaymentStatus)
            .IsInEnum()
            .NotNull();
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.UserAddressId)
            .NotNull();
        RuleFor(model => model.PaymentMethod)
            .IsInEnum();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserOrderRequest>.CreateWithOptions((CreateNewUserOrderRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
